<template>
  <div class="hello">
    <h1>{{ msg }}</h1>
    <div v-if="articles_status == REQUESTED">
      Please wait for articles to load...
      <button @click="cancel">Cancel</button>
    </div>
    <div v-else-if="articles_status == FAILED">
      Error loading articles: {{articles_error}}
      <button v-on:click="tryAgain">Try Again</button>
    </div>
    <div v-else-if="count"> <!-- same as this.$store.state.articles.length -->
			<Article
				v-for="article in articles"
        :key="article.id"
        :id="article.id"
				:title="article.title"
        :author="article.author"
        :isPublished="article.isPublished"
			/>
		</div>
		<p v-else>
			No articles in the list.
		</p>
    <p>
      <router-link to="/new">Add New Article</router-link>
    </p>
  </div>
</template>

<script>
import { mapState } from 'vuex';
import Article from './Article.vue';
import {Types} from '@/store/types.js';

export default {
  name: 'ArticleList',
  props: {
    msg: String
  },
  components: {
    Article
  },
  computed: mapState({
    count: state => state.articles.length,
    articles_status: 'articles_status',
    articles_error: 'articles_error',
    articles: 'articles'
  }),
  methods: {
    tryAgain() {
      this.$store.dispatch(Types.actions.ARTICLES_LOAD);
    },
    cancel() {
      this.$store.dispatch(Types.actions.ARTICLES_LOAD_CANCEL);
    }
  },
  created() {
    // Instantiate article status constants for template.
    this.REQUESTED = Types.request_status.REQUESTED;
    this.FAILED = Types.request_status.FAILED;
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}
</style>
